/*
 * setDistrib.java
 * project: XRel
 * @author Fabrizio Bisi
 * Created on 22-set-03
 */
package tools;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import xrel.XRel;   

/**
 * TODO insert comment here
 * @author Fabrizio Bisi
 */
public class setDistrib extends JPanel {
	final static int numDistrib = 4;
	final JFrame fr;
	
	JCheckBox[] distribButton = new JCheckBox[numDistrib];
	String[] distribStrings = {
		"1: public distribution",
		"2: private distribution",
		"3: full distribution",
		"4: (unused)"
	};
	boolean[] distribIncl = { true,true,true,false };

	public setDistrib(JFrame frame) {
		this.fr = frame;
		JLabel confirm = new JLabel("Prepare distributions",JLabel.CENTER);

		JPanel checkPanel = new JPanel();
		checkPanel.setLayout(new GridLayout(0, 1));
		CheckBoxListener checkListener = new CheckBoxListener();
		for (int i = 0; i < numDistrib; i ++) {
			// Create the check boxes
			distribButton[i] = new JCheckBox(distribStrings[i]);
			distribButton[i].setMnemonic(KeyEvent.VK_1 + i); 
			distribButton[i].setSelected(distribIncl[i]);
			// Register a listener for the check boxes.
			distribButton[i].addItemListener(checkListener);
			// Put the check boxes in a column in a panel
			checkPanel.add(distribButton[i]);
		}

		JPanel commandPanel = new JPanel();
		commandPanel.setLayout(new BorderLayout());

		JButton okButton = new JButton("Proceed");
		commandPanel.add(okButton, BorderLayout.WEST);
		okButton.setMnemonic('p');       
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				int n = JOptionPane.showConfirmDialog(
						fr, "Are you sure?",
						"Preparing distributions..",
						JOptionPane.YES_NO_OPTION);
				if (n == JOptionPane.YES_OPTION) {
					System.out.println("Eseguo:");
					for (int i=0; i<numDistrib; i++)
						if (distribIncl[i]) 
							System.out.println(distribStrings[i]);
				} else {
					System.out.println("Annullato");
				} 
				return;
			}
		});
		
		JButton cancelButton = new JButton("Abort");
		commandPanel.add(cancelButton, BorderLayout.EAST);
		cancelButton.setMnemonic('a');       
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.println("operazione annullata");
				System.exit(1);
				return;
			}
		});

		// Set the layout.
		setLayout(new BorderLayout());
		add(confirm, BorderLayout.NORTH);  
		add(checkPanel, BorderLayout.CENTER);
		add(commandPanel, BorderLayout.SOUTH);
	}

	/** Listens to the check boxes. */
	class CheckBoxListener implements ItemListener {
		public void itemStateChanged(ItemEvent e) {
			int index = 0;
			Object source = e.getItemSelectable();
			
			for (int i=0; i<numDistrib; i++)
				if (source == distribButton[i]) {
					index = i;
					break;
				} 
			
			if (e.getStateChange() == ItemEvent.DESELECTED)
				distribIncl[index] = false;
			else 
				distribIncl[index] = true;
		}
	}

	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (Exception exc) {
			System.err.println("Error loading L&F: " + exc);
		}

		JFrame frame = new JFrame("XRel " + XRel.VERSION_NUMBER);

		Container contentPane = frame.getContentPane();
		contentPane.setLayout(new GridLayout(1,1));
		contentPane.add(new setDistrib(frame));

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.pack();
		//frame.setLocationRelativeTo(null); JDK 1.4
		frame.setVisible(true);
	}
}

