/*
 * XReError.java
 * project: XRel
 * @author Fabrizio Bisi
 * Created on 28-lug-03
 */
package xrel;

/**
 * An error class. 
 * <p> XreError.showbug_and_exit(..) replaces everywhere in the code the 
 * following rows:
 * <ul>
 * <li> System.err.println("internal bug: ..."); </li>
 * <li> System.exit(1); </li>
 * </ul> </p>
 * <p> The function showerror_and_exit is as the previous one; what it changes 
 * is the prefix. </p>
 * <p> I won't use exceptions, they're don't seem practical to me
 * (not how they're deployed under Java). </p>
 * @author Fabrizio Bisi
 */
public final class XreError {
	public static void showbug_and_exit(String msg) {
		System.err.println("XRel internal bug: " + msg);
		System.exit(1);
	}
	public static void showerror_and_exit(String msg) {
		System.err.println("Fatal error: " + msg);
		System.exit(1);
	}
}
