/*
 * TASimpleState.java
 * project: XRel
 * @author Fabrizio Bisi
 * Created on 1-ott-03
 */
package xrel.analyzer;

import java.util.HashSet;
import java.util.Vector;

/**
 * TODO insert comment here
 * @author Fabrizio Bisi
 */
class TASimpleState implements TAState {
	private static int last_id = 0;
	private HashSet eps_clos;
	private int id;
	private Vector transitions; // q1 x label x content x q2 x list of variables 
	private boolean isFinal;
//	private boolean isInitial;
	
	/**
	 * Initializes a new tree automaton state.
	 */
	public TASimpleState() {
		id = ++last_id;
		eps_clos = null;
		transitions = new Vector();
		isFinal = false;
//		isInitial = false;
	}
//	/**
//	 * Returns the internal unique number that defines the state.
//	 * @return the id code of the state
//	 */
//	public int getId() {
//		return id;
//	}
	/**
	 * Returns a new state
	 */
	public Object clone() {
		TASimpleState newS = new TASimpleState();
		//newS.eps_clos.addAll(eps_clos); - wrong! states will change!
		//newS.transitions.addAll(transitions); - wrong! transitions will change
		// because states will change
		//newS.isFinal = isFinal; 
		//newS.id = id; - no! I don't want states with identical name
		return newS;
	}
	/**
	 * Gets the epsilon closure of this state. If you don't call 
	 * compute_closures() on the associated automaton this function
	 * returns null.
	 * @return the epsilon closure or null
	 */
	public HashSet get_epsClos() {
		return eps_clos;
	}
	/**
	 * Sets the epsilon closure of this state. Don't use this function,
	 * instead call compute_closures() on the associated automaton.
	 * @param e_clos the epsilon closure for the state
	 */
	public void set_epsClos(HashSet e_clos) {
		eps_clos = e_clos;
	}
	public Vector getTransitions() {
		return transitions;
	}
	public boolean isFinal() {
		return isFinal;
	}
	public void setFinal(boolean isFin) {
		isFinal = isFin;
	}
	/* only used by difference and intersection algs */
//	public boolean isInitial() {
//		return isInitial;
//	}
//	public void setInitial(boolean isInit) {
//		isInitial = isInit;
//	}
	/**
	 * Gets a string that represents the state.
	 * @return a string that represents the state
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return "q" + id;
	}
}